package com.yarin.android.Examples_08_09;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.UUID;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
//import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.Toast;

public class ClientSocketActivity extends Activity implements
		OnSeekBarChangeListener {
	private static final String TAG = ClientSocketActivity.class
			.getSimpleName();
	private static final int REQUEST_DISCOVERY = 0x1;;
	private Handler _handler = new Handler();
	private BluetoothAdapter _bluetooth = BluetoothAdapter.getDefaultAdapter();

	private BluetoothSocket socket = null;
	private TextView sTextView;
	// private EditText sEditText;
	private String str;
	private OutputStream outputStream;
	private InputStream inputStream;
	private StringBuffer sbu;

	TextView RGBnumbers;
	SeekBar sbR;
	SeekBar sbG;
	SeekBar sbB;
	int red, green, blue = 0;

	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_BLUR_BEHIND,
				WindowManager.LayoutParams.FLAG_BLUR_BEHIND);
		setContentView(R.layout.client_socket);
		if (!_bluetooth.isEnabled()) {
			finish();
			return;
		}
		Intent intent = new Intent(this, DiscoveryActivity.class);

		/* Prompted to select a server to connect */
		Toast.makeText(this, "select device to connect", Toast.LENGTH_SHORT)
				.show();

		/* Select device for list */
		startActivityForResult(intent, REQUEST_DISCOVERY);

		sTextView = (TextView) findViewById(R.id.sTextView);
		// sEditText = (EditText) findViewById(R.id.sEditText);

		Log.d("EF-BTBee", ">>setOnKeyListener");

		sbR = (SeekBar) findViewById(R.id.sbRed);
		sbG = (SeekBar) findViewById(R.id.sbGreen);
		sbB = (SeekBar) findViewById(R.id.sbBlue);
		
		RGBnumbers = (TextView) findViewById(R.id.tvRGBnumbers);
		// setting maximum Values
		sbR.setMax(255);
		sbG.setMax(255);
		sbB.setMax(255);

		sbR.setOnSeekBarChangeListener(this);
		sbG.setOnSeekBarChangeListener(this);
		sbB.setOnSeekBarChangeListener(this);
	}

	/*
	public void onButtonClicksend(View view) throws IOException {

		if (str != null) {
			Log.d("EF-BTBee", ">>second");
			sTextView.setText(str + "--> " + sEditText.getText());
			str += ("--> " + sEditText.getText().toString());
		} else {
			Log.d("EF-BTBee", ">>frist");
			sTextView.setText("--> " + sEditText.getText());
			str = "--> " + sEditText.getText().toString();
		}
		str += '\n';

		// Intent Extra is stored in String message
		Intent intent = getIntent();
		String RGBvalues = intent.getStringExtra(BT_Test_main.EXTRA_KEY);

		// String tmpStr = sEditText.getText().toString();
		byte bytes[] = RGBvalues.getBytes();
		outputStream.write(bytes);
	}
	*/

	/* after select, connect to device */
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode != REQUEST_DISCOVERY) {
			finish();
			return;
		}
		if (resultCode != RESULT_OK) {
			finish();
			return;
		}
		final BluetoothDevice device = data
				.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
		new Thread() {
			public void run() {
				connect(device);
			};
		}.start();
	}

	protected void onDestroy() {
		super.onDestroy();
		try {
			socket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			Log.e("EF-BTBee", ">>", e);
		}
	}

	protected void connect(BluetoothDevice device) {
		// BluetoothSocket socket = null;
		try {
			// Create a Socket connection: need the server's UUID number of
			// registered
			socket = device.createRfcommSocketToServiceRecord(UUID
					.fromString("00001101-0000-1000-8000-00805F9B34FB"));

			socket.connect();
			Log.d("EF-BTBee", ">>Client connectted");

			inputStream = socket.getInputStream();
			outputStream = socket.getOutputStream();
			int read = -1;
			final byte[] bytes = new byte[2048];
			for (; (read = inputStream.read(bytes)) > -1;) {
				final int count = read;
				_handler.post(new Runnable() {
					public void run() {
						StringBuilder b = new StringBuilder();
						for (int i = 0; i < count; ++i) {
							String s = Integer.toString(bytes[i]);
							b.append(s);
							b.append(",");
						}
						String s = b.toString();
						String[] chars = s.split(",");
						sbu = new StringBuffer();
						for (int i = 0; i < chars.length; i++) {
							sbu.append((char) Integer.parseInt(chars[i]));
						}
						Log.d("EF-BTBee", ">>inputStream");
						if (str != null) {
							sTextView.setText(str + "<-- " + sbu);
							str += ("<-- " + sbu.toString());
						} else {
							sTextView.setText("<-- " + sbu);
							str = "<-- " + sbu.toString();
						}
						str += '\n';
					}
				});
			}

		} catch (IOException e) {
			Log.e("EF-BTBee", ">>", e);
			finish();
			return;
		} finally {
			if (socket != null) {
				try {
					Log.d("EF-BTBee", ">>Client Socket Close");
					socket.close();
					finish();
					return;
				} catch (IOException e) {
					Log.e("EF-BTBee", ">>", e);
				}
			}
		}
	}

	public void onProgressChanged(SeekBar seekBar, int progress,
			boolean fromUser) {
		// TODO Auto-generated method stub
		// each seekBar
		switch (seekBar.getId()) {
		case R.id.sbRed:
			red = progress;
			break;
		case R.id.sbGreen:
			green = progress;
			break;
		case R.id.sbBlue:
			blue = progress;
			break;
		}

		// save processing speed
		try {
			Thread.sleep(60); // delay even longer, ca. 30fps to save processing
								// speed
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		String RGB_values = red + "," + green + "," + blue + "\n";
		byte bytes[] = RGB_values.getBytes();
		RGBnumbers.setText(RGB_values);	//show what has been sent
		
		try {
			outputStream.write(bytes);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void onStartTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub

	}

	public void onStopTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub

	}
	/* Fader button */
	public void onFader(View view)
	{
		String toArduinoFader = "fade";
		byte bytes2[] = toArduinoFader.getBytes();
		RGBnumbers.setText("Fader Mode");	//show what has been sent
		
		try {
			outputStream.write(bytes2);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/* Fire button */
	public void onFire(View view)
	{
		String toArduinoFire = "fire";
		byte bytes3[] = toArduinoFire.getBytes();
		RGBnumbers.setText("Fire Mode");	//show what has been sent
		
		try {
			outputStream.write(bytes3);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
